#
# gcc Makefile for ar65
#

CFLAGS 	= -g -O2 -Wall
CC	= gcc
LDFLAGS	=

OBJS = 	add.o		\
    	del.o		\
    	error.o		\
    	exports.o	\
    	extract.o	\
    	fileio.o	\
    	global.o	\
    	library.o	\
    	list.o		\
    	main.o		\
    	mem.o		\
    	objdata.o	\
    	objfile.o

LIBS = ../common/common.a


EXECS = ar65

.PHONY: all
ifeq (.depend,$(wildcard .depend))
all : $(EXECS)
include .depend
else
all:	depend
	@echo
	@echo Just say make again...
	@echo
endif



ar65:   $(OBJS) $(LIBS)
	$(CC) $(CFLAGS) -o $@ $(OBJS) $(LIBS)
					     
clean:
	rm -f *.o *~ core $(EXECS)

# ------------------------------------------------------------------------------
# Make the dependencies

.PHONY: depend dep
depend dep:	$(OBJS:.o=.c)
	@echo "Creating dependency information"
	$(CC) -MM $^ > .depend


