#
# gcc Makefile for a65, link65 & libr65
#

CFLAGS 	= -g -O2 -Wall
CC	= gcc
LDFLAGS	=

OBJS =  cputype.o	\
        ea.o		\
        error.o		\
        expr.o		\
        global.o       	\
        key816.o	\
	macpack.o	\
       	macro.o		\
        main.o		\
        mem.o		\
        objcode.o	\
        objfile.o	\
       	options.o	\
        pseudo.o	\
        scanner.o	\
        symtab.o	\
       	toknode.o

LIBS = ../common/common.a

EXECS = ca65

.PHONY: all
ifeq (.depend,$(wildcard .depend))
all : $(EXECS)
include .depend
else
all:	depend
	@echo
	@echo Just say make again...
	@echo
endif



ca65:   $(OBJS) $(LIBS)
	$(CC) $(CFLAGS) -o $@ $(OBJS) $(LIBS)

clean:
	rm -f *.o *~ core $(EXECS)

# ------------------------------------------------------------------------------
# Make the dependencies

.PHONY: depend dep
depend dep:	$(OBJS:.o=.c)
	@echo "Creating dependency information"
	$(CC) -MM $^ > .depend


