/*
 * global.h
 *
 * Ullrich von Bassewitz, 28.08.1998
 */



#ifndef GLOBAL_H
#define GLOBAL_H



/*****************************************************************************/
/*				     Data				     */
/*****************************************************************************/



/* Supported systems */
#define TGT_NONE	0
#define TGT_ATARI	1
#define TGT_C64		2
#define TGT_C128	3
#define TGT_ACE		4
#define TGT_PLUS4	5
#define TGT_CBM610	6
#define TGT_PET		7
#define TGT_NES		8
#define TGT_APPLE2	9
#define TGT_COUNT      10



extern unsigned char	Target;			/* Target system */
extern unsigned char	ANSI;			/* Strict ANSI flag */
extern unsigned char	WriteableStrings;	/* Literal strings are r/w */
extern unsigned char	NoWarn;			/* Suppress warnings */
extern unsigned char	Optimize;		/* Optimize flag */
extern unsigned char	FavourSize;		/* Favour size over speed */
extern unsigned char    InlineStdFuncs;	       	/* Inline some known functions */
extern unsigned char	EnableRegVars;		/* Enable register variables */
extern unsigned char	AllowRegVarAddr;	/* Allow taking addresses of register vars */
extern unsigned char	RegVarsToCallStack;	/* Save reg variables on call stack */
extern unsigned char 	LocalsAreStatic;	/* Make local variables static */
extern unsigned char	Verbose;		/* Verbose flag */
extern unsigned char	IncSource;		/* Include source as comments */
extern unsigned char	DebugInfo;		/* Add debug info to the obj */
extern unsigned char	Debug;			/* Debug mode */



/* End of global.h */

#endif




