#
# Makefile for cross-compiler version of CC65.
#


# Default for the compiler lib search path as compiler define
CDEFS=-DCC65_INC=\"/usr/lib/cc65/include/\"
CFLAGS = -O2 -g -Wall
CC=gcc
LDFLAGS=

OBJS =	check.o       	\
	codegen.o	\
	ctrans.o       	\
	datatype.o	\
	declare.o      	\
	error.o	 	\
	expr.o	 	\
	function.o     	\
	global.o 	\
	ident.o		\
	include.o     	\
	io.o		\
	litpool.o      	\
	loop.o		\
	macrotab.o	\
	main.o		\
	mem.o		\
	optimize.o     	\
	preproc.o      	\
	pragma.o       	\
	stdfunc.o	\
	stmt.o 		\
	symtab.o       	\
	scanner.o      	\
	util.o

EXECS = cc65


.PHONY: all
ifeq (.depend,$(wildcard .depend))
all : $(EXECS)
include .depend
else
all:	depend
	@echo
	@echo Just say make again...
	@echo
endif


cc65 : $(OBJS)
	$(CC) $(LDFLAGS) -o cc65 $(CFLAGS) $(OBJS)


clean :
	rm -f *.o *~ core $(EXECS) *.map

# ------------------------------------------------------------------------------
# Make the dependencies

.PHONY: depend dep
depend dep:	$(OBJS:.o=.c)
	@echo "Creating dependency information"
	$(CC) -MM $^ > .depend


