;
; Startup code for cc65 (NES version)
;
; This must be the *first* file on the linker command line
;

	.export	  	_exit
       	.import	       	__hinit, zerobss, copydata, pushax, doatexit
	.import	  	_main
	.import	  	NMI, IRQ


; ------------------------------------------------------------------------
; Define and export the ZP variables for the NES runtime

	.exportzp   	sp, sreg, regsave
	.exportzp   	ptr1, ptr2, ptr3, ptr4
	.exportzp   	tmp1, tmp2, tmp3, tmp4
	.exportzp	regbank, zpspace

sp     	=      	$00  		; stack pointer
sreg	=  	$02  		; secondary register/high 16 bit for longs
regsave	=      	$04  		; slot to save/restore (E)AX into
ptr1	=	$08  		;
ptr2	=	$0A
ptr3	=	$0C
ptr4	=	$0E
tmp1	=	$10
tmp2	=	$11
tmp3	=	$12
tmp4	=	$13
regbank	=	$14		; 6 byte register bank
zpspace = 	$1A

; ------------------------------------------------------------------------
; Startup code

; Setup the hardware stack pointer, enable interrupts
; (maybe h/w init needed here)

RESET:  cld	    		; Clear decimal mode
	ldx    	#$FF
	txs
	cli

; Initialize some registers

@L1:	lda 	$2002
        bpl 	@L1

        lda 	#$00
        sta 	$2005
  	sta 	$2005
  	sta 	$2006
  	sta 	$2006

; Clear the BSS data

  	jsr	zerobss

; Copy the initialized data in place.

  	jsr	copydata

; Setup the software stack. We will create two words of zero on top of stack
; here which will be interpreted as the arguments to main() later.

@L3:	lda    	#<$07FC
    	sta	sp
    	lda	#>$07FC
      	sta	sp+1   		; Set argument stack ptr

    	ldy	#3
    	lda	#$00
@L5:	sta	(sp),y
   	dey
   	bpl	@L5

; Initialize the heap

  	jsr	__hinit

; Initialize conio stuff

; 	jsr	initconio

; Call main() - the arguments are already in place

  	ldy	#4  	 	; Argument size
       	jsr    	_main	 	; call the users code

; fall thru to exit...

_exit:	jsr	doatexit 	; call exit functions

; Not sure what to do here...

  	jmp	RESET

; ------------------------------------------------------------------------
; Hardware vectors. The VECTORS segment is put at $FFFA by the linker.

.segment	"VECTORS"

  	.word	NMI 		; NMI vector
  	.word  	RESET		; Reset vector
  	.word	IRQ 		; IRQ vector


		   
