;This contains functions that handle all the nes registers.  This includes
;PPU control registers, direct memory read/writes of PPU and sprite memory,
;Controller handling, sprite DMA transfers, and so on.


                .export _SetPPUctrl, _ReadPPUstat, _WriteScroll
                .import popa
                .importzp tmp1,tmp2


; void __fastcall__ SetPPUctrl (unsigned char num, unsigned char value);
; Sets the values in one of the PPU control registers

_SetPPUctrl:
	pha	    		; Save value
	jsr	popa		; Get num...
	tay	    		; ...into Y
	pla
	sta	$2000,y
	rts


; unsigned char ReadPPUstat (void);
; Reads the PPU status register (usually to check for vblank)

_ReadPPUstat:
	lda	$2002
	ldx	#$00
	rts


; void __fastcall__ WriteScroll (unsigned char vert, unsigned char horiz);
; Scroll register

_WriteScroll:
	sta	$2005		; Store horiz
	jsr	popa		; Get vert
	sta	$2005		; Store vert
	rts

