;These are built-in library routines for palette manipulation.
;This includes reading/writing individual values, as well as loading
;the entire palette at once.  Remember that there are two seperate
;16 color palettes, one for the background, one for the sprites

	.export 	_SetBGpalette, _SetSPRpalette
	.export		_LoadBGpalette, _LoadSPRpalette

        .import		popa
        .importzp 	tmp1, ptr1


; void __fastcall__ SetBGpalette (unsigned char num, unsigned char val)
; Sets background palette num to val

_SetBGpalette:
	pha			; Save val
	jsr	popa		; Get num
	ldx	#$3F
	stx	$2006
	sta	$2006
	pla
	sta	$2007
	rts

; void __fastcall__ SetSPRpalette (unsigned char num, unsigned char val);
; Same as above for sprite palette

_SetSPRpalette:
	pha			; Save val
	jsr	popa
	clc
	adc	#$10
	ldx	#$3F
	stx	$2006
	sta	$2006
	pla
	sta	$2007
	rts

; void __fastcall__ LoadBGpalette (unsigned char* palette)
; Loads the entire background palette at once
; WROOONNNGGG !!! Do not use now

_LoadBGpalette:
	sta	ptr1
	stx	ptr1+1	   	; Save palette pointer

        ldy 	#0
@L1:    lda 	(ptr1),y
        sta 	$3F00,y
        dey
        bpl 	@L1
        rts

; void __fastcall__ LoadSPRpalette (unsigned char* palette)
; Loads the entire sprite palette at once
; WRONG TOO !!!

_LoadSPRpalette:
	sta	ptr1
	stx	ptr1+1		; Save palette pointer

	ldy 	#0
@L1:	lda 	(ptr1),y
	sta 	$3F10,y
	dey
        bpl 	@L1
	rts

	
