;This file contains functions for accessing the ppu memory.
;Remember that you must set the address when using the raw i/o functions
;Otherwise, use the direct read/write, which doesn't make use of the
;auto-increment.

; void __fastcall__ ReadPPU (unsigned addr)
; Reads a byte of the PPU at addr.

            .export _ReadPPU, _WritePPU, _SetPPUaddress, _ReadPPUseq
            .export _WritePPUseq

            .import popa

_ReadPPU:
	stx	$2006
	sta	$2006
	lda	$2007
	lda	$2007
	ldx	#0
	rts


; void __fastcall__ WritePPU (unsigned char value, unsigned addr)
; Writes value to PPU memory at addr

_WritePPU:
	stx	$2006
	sta	$2006
	jsr	popa
	sta	$2007
	rts


; void __fastcall__ SetPPUaddress (unsigned address)
; Sets the address for sequential reads/writes

_SetPPUaddress:
	stx	$2006
	sta	$2006
	rts


; unsigned char ReadPPUseq (void)
; Reads seqentially (in conjunction with SetPPUaddress)
; REMEMBER ABOUT THE TRASH READ!!! (Will be fixed with a var)

_ReadPPUseq:
	lda 	$2007
	ldx 	#0
	rts


; void __fastcall__ WritePPUseq (unsigned char value)
; Writes sequentially (in conjunction with SetPPUaddress)

_WritePPUseq:
	sta $2007
        rts

