;Sprite handling functions
;These are used to move sprites around, animate them, etc...

; SetSpriteXY(byte sprite, byte x, byte y)
; Move sprite to x,y

          .importzp tmp1, tmp2, tmp3
          .import popax,pushax
          
          .export _SetSpriteXY
          .export _SetSpriteX
          .export _SetSpriteY
          .export _SetSpriteIdx
          .export _SetSpriteAttrib
          .export _SpriteDMA
          .export _ScrollSpriteX
          .export _ScrollSpriteY
          .export _ScrollSpriteXY


_SetSpriteXY:
                jsr popax               ;Get Y coord
                sta tmp1                ;Save it
                jsr popax               ;Get X coord
                sta tmp2                ;Save it
                jsr popax               ;Get sprite num
                ldx tmp2                ;Load X into X
                ldy tmp1                ;Load Y into Y
                asl a                   ;Multiply by 4 (4 bytes per sprite)
                asl a
                sta $2003               ;Store address for Y coord
                sty $2004               ;Store Y coord
                clc                     
                adc #3                  ;Calc address for X coord (+3)
                sta $2003               ;Store address
                stx $2004               ;Store X coord
                rts                     ;Done!

_SetSpriteX:
                jsr popax               ;Get X coord
                sta tmp1                ;Save it
                jsr popax               ;Get sprite num
                ldx tmp1                ;Load X coord
                asl a
                asl a
                clc
                adc #3                  ;Add X coord offset (+3)
                sta $2003               ;Store address
                stx $2004               ;Store X coord
                rts

_SetSpriteY:
                jsr popax               ;Get Y coord
                sta tmp1
                jsr popax               ;Get sprite num
                ldx tmp1                ;Load Y coord
                asl a
                asl a
                sta $2003               ;Store addres
                stx $2004               ;Store Y coord
                rts

_SetSpriteIdx:
                jsr popax
                sta tmp1
                jsr popax
                ldx tmp1
                asl a
                asl a
                clc
                adc #1
                sta $2003
                stx $2004
                rts                

_SetSpriteAttrib:
                jsr popax
                sta tmp1
                jsr popax
                ldx tmp1
                asl a
                asl a
                clc
                adc #2
                sta $2003
                stx $2004
                rts

_SpriteDMA:
                jsr popax
                sta $4014
                rts

;ScrollSpriteX(sprite, x)

_ScrollSpriteX:
                jsr popax
                sta tmp1                ;Save x offset
                jsr popax               ;get mem
                asl a
                asl a
                clc
                adc #3                  ;X is 3 from sprite
                sta tmp3                ;Save mem offset
                sta $2003
                lda $2004
                sta tmp2                ;Save current y position
                lda tmp1                ;Load x scroll...check sign
                bpl SSYup
                bpl SSXright
                and #$7F                ;Clear sign flag...?
                clc
                sbc tmp2                ;Scroll left
                sta tmp2
                ldy #0
                jmp SSXfin
SSXright:       and #$7F                ;Clear sign flag...?
                clc
                adc tmp2                ;Scroll right
                sta tmp2                ;Save new x position
SSXfin:         lda tmp3                ;Get old sprite mem address
                sta $2003               ;Write it
                lda tmp2                ;Get new x pos.
                sta $2004               ;Write it
                rts


;ScrollSpriteY(sprite,y)

_ScrollSpriteY:
                jsr popax
                sta tmp1                ;Save y offset
                jsr popax               ;get mem
                asl a
                asl a
                sta tmp3                ;Save mem offset
                sta $2003
                lda $2004
                sta tmp2                ;Save current y position
                lda tmp1                ;Load y scroll...check sign
                bpl SSYup
                and #$7F
                clc
                sbc tmp2                ;Scroll down
                sta tmp2                ;Save it
                jmp SSYfin
SSYup:          and #$7F                
                clc
                adc tmp2                ;Scroll up
                sta tmp2                ;Save new y position
SSYfin:         lda tmp3                ;Get old sprite mem address
                sta $2003               ;Write it
                lda tmp2                ;Get new y pos.
                sta $2004               ;Write it
                rts

;ScrollSpriteXY(sprite,x,y)

_ScrollSpriteXY:
                jsr popax
                sta tmp2                ;Save Y
                jsr popax
                sta tmp1                ;Save X
                jsr popax
                asl a
                asl a
                sta tmp3                ;Save mem offset
                sta $2003
                ldy $2004               ;Get current y
                ldx $2004               ;Ignore this read
                ldx $2004               ;Ignore this read
                ldx $2004               ;Get current x
                lda tmp1                ;Check x first
                bpl SXYright
                and #$7F                ;Clear sign bit
                txa
                clc
                sbc tmp1                ;Subtract offset
                sta tmp1                ;Save new location (X)
                jmp SXYnext
SXYright:       and #$7F                ;Clear sign bit
                txa
                clc
                adc tmp1                ;Add offset
                sta tmp1                ;Save new location (X)

SXYnext:        lda tmp2                ;Check y next
                bpl SXYup
                and #$7F
                tya
                clc
                sbc tmp2
                sta tmp2
                jmp SXYfin
SXYup:          and #$7F
                tya
                clc
                adc tmp2
                sta tmp2

SXYfin:         lda tmp3                ;Get mem offset
                sta $2003               ;Set sprite mem address
                lda tmp2                ;Get new y location
                sta $2004               ;save it
                lda $2004               ;Ignore this read
                lda $2004               ;Ignore this read
                lda tmp1                ;Get new x location
                sta $2004               ;save it
                rts
